#ifdef __REQUIRED__

promdef.h
prd_00types.h
oi_060general.h

#endif

#if 0
VERS____( oi_406anno_types.h - basic Anno-OI types, Bre/Mt/Gl, 94/01/17)
#endif

/******************************************************************************
:++
:
HEADER_FILE 		oi_406anno_types.h

:PURPOSE

Definition of Annotation specific Constants and Structures

:AUTHOR

Bre/Mt 91/06/14

:CHANGES

ProSQL Annotations, Gl, 93/11/02

:END
:--
******************************************************************************/

/*
**    Trace Switches
*/

#define OI_T_ANNO_CSQL		0x00001
/*P*/
/*
**	Constants for Annotation Attributes
*/

/*	ProMod/SI specific Attributes 					*/
#define OI_AA_LOCATION			 99

/*	ProMod/SI specific Attributes needed for Subsystems and Modules */
#define OI_AA_INTERFACE_TEXT		100
#define OI_AA_BODY_TEXT			101
#define OI_AA_INTERFACE_REF		102
#define OI_AA_INTERFACE_REF_TOOL	103
#define OI_AA_BODY_REF			104
#define OI_AA_BODY_REF_TOOL		105
#define OI_AA_INTERFACE_TARGET		106
#define OI_AA_INTERFACE_TARGET_TOOL	107
#define OI_AA_BODY_TARGET		108
#define OI_AA_BODY_TARGET_TOOL		109

/*	ProMod/SI specific Attributes needed for Functions */
#define OI_AA_OPERATION_TEXT		110
#define OI_AA_OPERATION_REF		111
#define OI_AA_OPERATION_REF_TOOL	112
#define OI_AA_OPERATION_TARGET		113
#define OI_AA_OPERATION_TARGET_TOOL	114

/*	ProMod/SI specific Attributes needed for MD+  */
#define OI_AA_MER_UNIQUE_NAME_TABLE	115

/* 	Specific Attributes needed for MD+  */
/* #define OI_AA_BASIC_TYPE_TABLE		116 */

/*	Attributes needed for free text annotation     */
#define OI_AA_TEXT1			117
#define OI_AA_TEXT2			118
#define OI_AA_TEXT3			119
#define OI_AA_TEXT4			120
#define OI_AA_TEXT5			121

/*	Attributes needed for file reference annotation   */
#define OI_AA_FILE1			122
#define OI_AA_TOOL1			123
#define OI_AA_FILE2			124
#define OI_AA_TOOL2			125
#define OI_AA_FILE3			126
#define OI_AA_TOOL3			127
#define OI_AA_FILE4			128
#define OI_AA_TOOL4			129
#define OI_AA_FILE5			130
#define OI_AA_TOOL5			131

/*	Attributes needed for Projectinformation          */
#define OI_AA_AUTHOR			132
#define OI_AA_CREATION			133
#define OI_AA_UPDATE			134
#define OI_AA_ANALYZE			135

/*	Attributes needed for ShortCut Information		*/
#define OI_AA_SC_PSPEC			136
#define OI_AA_SC_DATATYPE		137
#define OI_AA_SC_PASSIVITY		138
#define OI_AA_SC_INITVAL		139
#define OI_AA_SC_METHOD			140
#define OI_AA_SC_STR_LEN		351
#define OI_AA_SC_ENUM_TYPE		352

/*	Attributes needed for userdefined names of free text
	and file attributes					*/
#define OI_AA_FD_TEXT1			141
#define OI_AA_FD_TEXT2			142
#define OI_AA_FD_TEXT3			143
#define OI_AA_FD_TEXT4			144
#define OI_AA_FD_TEXT5			145
#define OI_AA_FD_FILE1			146
#define OI_AA_FD_FILE2			147
#define OI_AA_FD_FILE3			148
#define OI_AA_FD_FILE4			149
#define OI_AA_FD_FILE5			150

#define OI_AA_TRM_TEXT1			151
#define OI_AA_TRM_TEXT2			152
#define OI_AA_TRM_TEXT3			153
#define OI_AA_TRM_TEXT4			154
#define OI_AA_TRM_TEXT5			155
#define OI_AA_TRM_FILE1			156
#define OI_AA_TRM_FILE2			157
#define OI_AA_TRM_FILE3			158
#define OI_AA_TRM_FILE4			159
#define OI_AA_TRM_FILE5			160

#define OI_AA_MSP_TEXT1			161
#define OI_AA_MSP_TEXT2			162
#define OI_AA_MSP_TEXT3			163
#define OI_AA_MSP_TEXT4			164
#define OI_AA_MSP_TEXT5			165
#define OI_AA_MSP_FILE1			166
#define OI_AA_MSP_FILE2			167
#define OI_AA_MSP_FILE3			168
#define OI_AA_MSP_FILE4			169
#define OI_AA_MSP_FILE5			170

#define OI_AA_CSP_TEXT1			171
#define OI_AA_CSP_TEXT2			172    	
#define OI_AA_CSP_TEXT3			173
#define OI_AA_CSP_TEXT4			174
#define OI_AA_CSP_TEXT5			175
#define OI_AA_CSP_FILE1			176
#define OI_AA_CSP_FILE2			177
#define OI_AA_CSP_FILE3			178
#define OI_AA_CSP_FILE4			179
#define OI_AA_CSP_FILE5			180

#define OI_AA_SHEET_TEXT1		181
#define OI_AA_SHEET_TEXT2		182
#define OI_AA_SHEET_TEXT3		183
#define OI_AA_SHEET_TEXT4		184
#define OI_AA_SHEET_TEXT5		185
#define OI_AA_SHEET_FILE1		186
#define OI_AA_SHEET_FILE2		187
#define OI_AA_SHEET_FILE3		188
#define OI_AA_SHEET_FILE4		189
#define OI_AA_SHEET_FILE5		190

#define OI_AA_STATE_TEXT1		191
#define OI_AA_STATE_TEXT2		192
#define OI_AA_STATE_TEXT3		193
#define OI_AA_STATE_TEXT4		194
#define OI_AA_STATE_TEXT5		195
#define OI_AA_STATE_FILE1		196
#define OI_AA_STATE_FILE2		197
#define OI_AA_STATE_FILE3		198
#define OI_AA_STATE_FILE4		199
#define OI_AA_STATE_FILE5		200

#define OI_AA_TRANS_TEXT1		201
#define OI_AA_TRANS_TEXT2		202
#define OI_AA_TRANS_TEXT3		203
#define OI_AA_TRANS_TEXT4		204
#define OI_AA_TRANS_TEXT5		205
#define OI_AA_TRANS_FILE1		206
#define OI_AA_TRANS_FILE2		207
#define OI_AA_TRANS_FILE3		208
#define OI_AA_TRANS_FILE4		209
#define OI_AA_TRANS_FILE5		210

#define OI_AA_DATA_TEXT1		211
#define OI_AA_DATA_TEXT2		212
#define OI_AA_DATA_TEXT3		213
#define OI_AA_DATA_TEXT4		214
#define OI_AA_DATA_TEXT5		215
#define OI_AA_DATA_FILE1		216
#define OI_AA_DATA_FILE2		217
#define OI_AA_DATA_FILE3		218
#define OI_AA_DATA_FILE4		219
#define OI_AA_DATA_FILE5		220

#define OI_AA_ERD_TEXT1			221
#define OI_AA_ERD_TEXT2			222
#define OI_AA_ERD_TEXT3			223
#define OI_AA_ERD_TEXT4			224
#define OI_AA_ERD_TEXT5			225
#define OI_AA_ERD_FILE1			226
#define OI_AA_ERD_FILE2			227
#define OI_AA_ERD_FILE3			228
#define OI_AA_ERD_FILE4			229
#define OI_AA_ERD_FILE5			230

#define OI_AA_ERM_TEXT1			231
#define OI_AA_ERM_TEXT2			232
#define OI_AA_ERM_TEXT3			233
#define OI_AA_ERM_TEXT4			234
#define OI_AA_ERM_TEXT5			235
#define OI_AA_ERM_FILE1			236
#define OI_AA_ERM_FILE2			237
#define OI_AA_ERM_FILE3			238
#define OI_AA_ERM_FILE4			239
#define OI_AA_ERM_FILE5			240

#define OI_AA_CON_TEXT1			241
#define OI_AA_CON_TEXT2			242
#define OI_AA_CON_TEXT3			243
#define OI_AA_CON_TEXT4			244
#define OI_AA_CON_TEXT5			245
#define OI_AA_CON_FILE1			246
#define OI_AA_CON_FILE2			247
#define OI_AA_CON_FILE3			248
#define OI_AA_CON_FILE4			249
#define OI_AA_CON_FILE5			250

#define OI_AA_SH_TEXT1			251
#define OI_AA_SH_TEXT2	       		252
#define OI_AA_SH_TEXT3			253
#define OI_AA_SH_TEXT4			254
#define OI_AA_SH_TEXT5			255
#define OI_AA_SH_FILE1			256
#define OI_AA_SH_FILE2			257
#define OI_AA_SH_FILE3			258
#define OI_AA_SH_FILE4			259
#define OI_AA_SH_FILE5			260

#define OI_AA_SUB_TEXT1			261
#define OI_AA_SUB_TEXT2			262
#define OI_AA_SUB_TEXT3			263
#define OI_AA_SUB_TEXT4			264
#define OI_AA_SUB_TEXT5			265
#define OI_AA_SUB_FILE1			266
#define OI_AA_SUB_FILE2			267
#define OI_AA_SUB_FILE3			268
#define OI_AA_SUB_FILE4			269
#define OI_AA_SUB_FILE5			270

#define OI_AA_ISU_TEXT1			271
#define OI_AA_ISU_TEXT2			272
#define OI_AA_ISU_TEXT3			273
#define OI_AA_ISU_TEXT4			274
#define OI_AA_ISU_TEXT5			275
#define OI_AA_ISU_FILE1			276
#define OI_AA_ISU_FILE2			277
#define OI_AA_ISU_FILE3			278
#define OI_AA_ISU_FILE4			279
#define OI_AA_ISU_FILE5			280

#define OI_AA_MH_TEXT1			281
#define OI_AA_MH_TEXT2			282
#define OI_AA_MH_TEXT3			283
#define OI_AA_MH_TEXT4			284
#define OI_AA_MH_TEXT5			285
#define OI_AA_MH_FILE1			286
#define OI_AA_MH_FILE2			287
#define OI_AA_MH_FILE3			288
#define OI_AA_MH_FILE4			289
#define OI_AA_MH_FILE5			290

#define OI_AA_MOD_TEXT1			291
#define OI_AA_MOD_TEXT2			292
#define OI_AA_MOD_TEXT3			293
#define OI_AA_MOD_TEXT4			294
#define OI_AA_MOD_TEXT5			295
#define OI_AA_MOD_FILE1			296
#define OI_AA_MOD_FILE2			297
#define OI_AA_MOD_FILE3			298
#define OI_AA_MOD_FILE4			299
#define OI_AA_MOD_FILE5			300

#define OI_AA_IMO_TEXT1			301
#define OI_AA_IMO_TEXT2			302
#define OI_AA_IMO_TEXT3			303
#define OI_AA_IMO_TEXT4			304
#define OI_AA_IMO_TEXT5			305
#define OI_AA_IMO_FILE1			306
#define OI_AA_IMO_FILE2			307
#define OI_AA_IMO_FILE3			308
#define OI_AA_IMO_FILE4			309
#define OI_AA_IMO_FILE5			310

#define OI_AA_FUN_TEXT1			311
#define OI_AA_FUN_TEXT2			312
#define OI_AA_FUN_TEXT3			313
#define OI_AA_FUN_TEXT4			314
#define OI_AA_FUN_TEXT5			315
#define OI_AA_FUN_FILE1			316
#define OI_AA_FUN_FILE2			317
#define OI_AA_FUN_FILE3			318
#define OI_AA_FUN_FILE4			319
#define OI_AA_FUN_FILE5			320

#define OI_AA_IFU_TEXT1			321
#define OI_AA_IFU_TEXT2			322
#define OI_AA_IFU_TEXT3			323
#define OI_AA_IFU_TEXT4			324
#define OI_AA_IFU_TEXT5			325
#define OI_AA_IFU_FILE1			326
#define OI_AA_IFU_FILE2			327
#define OI_AA_IFU_FILE3			328
#define OI_AA_IFU_FILE4			329
#define OI_AA_IFU_FILE5			330

#define OI_AA_PRO_TEXT1			331
#define OI_AA_PRO_TEXT2			332
#define OI_AA_PRO_TEXT3			333
#define OI_AA_PRO_TEXT4			334
#define OI_AA_PRO_TEXT5			335
#define OI_AA_PRO_FILE1			336
#define OI_AA_PRO_FILE2			337
#define OI_AA_PRO_FILE3			338
#define OI_AA_PRO_FILE4			339
#define OI_AA_PRO_FILE5			340

#define OI_AA_BTYP_TEXT1		341
#define OI_AA_BTYP_TEXT2		342
#define OI_AA_BTYP_TEXT3		343
#define OI_AA_BTYP_TEXT4		344
#define OI_AA_BTYP_TEXT5		345
#define OI_AA_BTYP_FILE1		346
#define OI_AA_BTYP_FILE2		347
#define OI_AA_BTYP_FILE3		348
#define OI_AA_BTYP_FILE4		349
#define OI_AA_BTYP_FILE5		350

#define OI_AA_TSK_TEXT1			361
#define OI_AA_TSK_TEXT2			362
#define OI_AA_TSK_TEXT3			363
#define OI_AA_TSK_TEXT4			364
#define OI_AA_TSK_TEXT5			365
#define OI_AA_TSK_FILE1			366
#define OI_AA_TSK_FILE2			367
#define OI_AA_TSK_FILE3			368
#define OI_AA_TSK_FILE4			369
#define OI_AA_TSK_FILE5			370

#define OI_AA_TSK_DIA_TEXT1		371
#define OI_AA_TSK_DIA_TEXT2		372
#define OI_AA_TSK_DIA_TEXT3		373
#define OI_AA_TSK_DIA_TEXT4		374
#define OI_AA_TSK_DIA_TEXT5		375
#define OI_AA_TSK_DIA_FILE1		376
#define OI_AA_TSK_DIA_FILE2		377
#define OI_AA_TSK_DIA_FILE3		378
#define OI_AA_TSK_DIA_FILE4		379
#define OI_AA_TSK_DIA_FILE5		380

#define OI_AA_TSK_EVENT_TEXT1		381
#define OI_AA_TSK_EVENT_TEXT2		382
#define OI_AA_TSK_EVENT_TEXT3		383
#define OI_AA_TSK_EVENT_TEXT4		384
#define OI_AA_TSK_EVENT_TEXT5		385
#define OI_AA_TSK_EVENT_FILE1		386
#define OI_AA_TSK_EVENT_FILE2		387
#define OI_AA_TSK_EVENT_FILE3		388
#define OI_AA_TSK_EVENT_FILE4		389
#define OI_AA_TSK_EVENT_FILE5		390

#define OI_AA_TSK_MESS_TEXT1		391
#define OI_AA_TSK_MESS_TEXT2		392
#define OI_AA_TSK_MESS_TEXT3		393
#define OI_AA_TSK_MESS_TEXT4		394
#define OI_AA_TSK_MESS_TEXT5		395
#define OI_AA_TSK_MESS_FILE1		396
#define OI_AA_TSK_MESS_FILE2		397
#define OI_AA_TSK_MESS_FILE3		398
#define OI_AA_TSK_MESS_FILE4		399
#define OI_AA_TSK_MESS_FILE5		400

/*	Attributes needed for V1.1u extensions 	*/

/* 351, 352 siehe oben! */

#define OI_AA_KEY			353
#define OI_AA_SUB_TYPE			354
#define OI_AA_MOD_TYPE			355
#define OI_AA_TYPE_STR			356
#define OI_AA_FD_FUN_PROP		357


/*
** ProSQL Annotations for Entities and Relationships
*/
#define OI_AA_ER_AMALGAMATE		401
#define OI_AA_ER_USER			402
#define OI_AA_ER_TABLESPACE		404
#define OI_AA_ER_STORAGE		405
#define OI_AA_ER_CLUSTER		406
#define OI_AA_ER_ASQUERY		407
#define OI_AA_ER_PCTFREE		408
#define OI_AA_ER_PCTUSED		409
#define OI_AA_ER_INITRANS		410
#define OI_AA_ER_MAXTRANS		411
#define OI_AA_ER_CONSTRAINT		412
#define OI_AA_ER_TR1	      		421
#define OI_AA_ER_EPILOG	      		422
#define OI_AA_ER_CHECK			423

#if 0
// ProFace und sonstige Erweiterungen (noch nicht implementiert)
#define OI_AA_ER_LANGUAGE		403
#define OI_AA_ER_ONCOMMIT		413
#define OI_AA_ER_DBMS  			415
#define OI_AA_ER_INTERFACE		416
#define OI_AA_ER_INDB			417
#define OI_AA_ER_MIN			418
#define OI_AA_ER_MAX	       		419
#define OI_AA_ER_UPDATE	      		420
#endif

/*
** ProSQL Annotations for Attributes (or Fields)
*/
#define OI_AA_AT_NOTNULL		444
#define OI_AA_AT_DOMAINVALUE		448
#define OI_AA_AT_DEFAULT		451
#define OI_AA_AT_CHECK			452
#define OI_AA_AT_CONSTRAINT		453

#if 0
// ProFace und sonstige Erweiterungen (noch nicht implementiert)
#define OI_AA_AT_PRIMARY_KEY		441
#define OI_AA_AT_NOT_IN_DB		442
#define OI_AA_AT_INDEX_KEY1		445
#define OI_AA_AT_INDEX_KEY2		446
#define OI_AA_AT_UNIQUE			447
#define OI_AA_AT_COLLATE		454
#define OI_AA_AT_DESCENDING		456
#define OI_AA_AT_SYNTAX			457
#define OI_AA_AT_LAYOUT	   		458
#endif

/*
** ProSQL Annotations for ER-Connections
*/
#define OI_AA_CO_ONDELETE		483
#define OI_AA_CO_COMMENT		484

#if 0
// ProFace und sonstige Erweiterungen (noch nicht implementiert)
#define OI_AA_CO_MATCHTYPE		481
#define OI_AA_CO_ONUPDATE		482
#endif

/*
** ProSQL Results
*/

#define OI_AA_ER_CREATETABLE		498

#if 0
// ProFace und sonstige Erweiterungen (noch nicht implementiert)
#define OI_AA_ER_SELECTSTATEMENT	499
#endif

/*
** ProSQL Project Annotation
*/

#define OI_AA_PS_PROLOG			501
#define OI_AA_PS_EPILOG			502
#if 0
// ProFace und sonstige Erweiterungen (noch nicht implementiert)
#define OI_AA_PS_DOMAINDEF		503
#endif


/*
** Proteus Annotations
*/
#define OI_AA_INTERFACE_FILE		1000
#define OI_AA_BODY_FILE			1001

/*
** OO Annotations
*/                
#define OI_AA_BODY_INCLUDES		1003
#define OI_AA_SPEC_INCLUDES		1004
#define OI_AA_MAKEFILE_TEXT		1005
#define OI_AA_MAKEFILE_REF		1006
#define OI_AA_MAKEFILE_REF_TOOL		1007
#define OI_AA_MAKEFILE_TARGET		1008

#define OI_AA_OO_SUB_TEXT1		1011
#define OI_AA_OO_SUB_TEXT2		1012
#define OI_AA_OO_SUB_TEXT3		1013
#define OI_AA_OO_SUB_TEXT4		1014
#define OI_AA_OO_SUB_TEXT5		1015
#define OI_AA_OO_SUB_FILE1		1016
#define OI_AA_OO_SUB_FILE2		1017
#define OI_AA_OO_SUB_FILE3		1018
#define OI_AA_OO_SUB_FILE4		1019
#define OI_AA_OO_SUB_FILE5		1020

#define OI_AA_OO_CLASS_TEXT1		1021
#define OI_AA_OO_CLASS_TEXT2		1022
#define OI_AA_OO_CLASS_TEXT3		1023
#define OI_AA_OO_CLASS_TEXT4		1024
#define OI_AA_OO_CLASS_TEXT5		1025
#define OI_AA_OO_CLASS_FILE1		1026
#define OI_AA_OO_CLASS_FILE2		1027
#define OI_AA_OO_CLASS_FILE3		1028
#define OI_AA_OO_CLASS_FILE4		1029
#define OI_AA_OO_CLASS_FILE5		1030

#define OI_AA_OO_EVTR_TEXT1		1031
#define OI_AA_OO_EVTR_TEXT2		1032
#define OI_AA_OO_EVTR_TEXT3		1033
#define OI_AA_OO_EVTR_TEXT4		1034
#define OI_AA_OO_EVTR_TEXT5		1035
#define OI_AA_OO_EVTR_FILE1		1036
#define OI_AA_OO_EVTR_FILE2		1037
#define OI_AA_OO_EVTR_FILE3		1038
#define OI_AA_OO_EVTR_FILE4		1039
#define OI_AA_OO_EVTR_FILE5		1040

#define OI_AA_OO_OBJECT_TEXT1		1041
#define OI_AA_OO_OBJECT_TEXT2		1042
#define OI_AA_OO_OBJECT_TEXT3		1043
#define OI_AA_OO_OBJECT_TEXT4		1044
#define OI_AA_OO_OBJECT_TEXT5		1045
#define OI_AA_OO_OBJECT_FILE1		1046
#define OI_AA_OO_OBJECT_FILE2		1047
#define OI_AA_OO_OBJECT_FILE3		1048
#define OI_AA_OO_OBJECT_FILE4		1049
#define OI_AA_OO_OBJECT_FILE5		1050

#define OI_AA_OO_STD_TEXT1		1051
#define OI_AA_OO_STD_TEXT2		1052
#define OI_AA_OO_STD_TEXT3		1053
#define OI_AA_OO_STD_TEXT4		1054
#define OI_AA_OO_STD_TEXT5		1055
#define OI_AA_OO_STD_FILE1		1056
#define OI_AA_OO_STD_FILE2		1057
#define OI_AA_OO_STD_FILE3		1058
#define OI_AA_OO_STD_FILE4		1059
#define OI_AA_OO_STD_FILE5		1060

/*
** possible values for annotation attributes OI_AA_SUB_TYPE, OI_AA_MOD_TYPE
*/
#define OI_AV_PROGRAM			0x01
#define OI_AV_DATA			0x02
#define OI_AV_EXTERNAL			0x03
#define OI_AV_USERDEF			0x04


/*
** possible value for annotation attribute OI_AA_FD_FUN_PROP
*/

#define OI_AV_FUN_TRUE			0x01
#define OI_AV_FUN_FALSE			0x02

/*P*/
/*
**	Constants for obj_type
**	Warum muessen das Bitmasken sein? 	--Gl
*/
/*
** MD+ Objects
*/                                      
#define OI_ANNO_SUB			0x00000001L
#define OI_ANNO_MO			0x00000002L
#define OI_ANNO_FU		 	0x00000004L
#define OI_ANNO_SUBH			0x00000008L
#define OI_ANNO_IMP_SUB			0x00000010L
#define OI_ANNO_IMP_MO			0x00000020L
#define OI_ANNO_MOH                    	0x00000040L
#define OI_ANNO_IMP_FU			0x00000080L
#define OI_ANNO_EXP_FU			0x00000100L
/*
** SA/RT Objects
*/
#define OI_ANNO_FD			0x00000200L
#define OI_ANNO_NODE                   	0x00000400L
#define OI_ANNO_STORE                  	0x00000800L
#define OI_ANNO_TERM			0x00001000L
#define OI_ANNO_DF                     	0x00002000L
#define OI_ANNO_CF                     	0x00004000L
#define OI_ANNO_BAR                    	0x00008000L
#define OI_ANNO_CSP             	0x00010000L
#define OI_ANNO_MSP			0x00020000L
#define OI_ANNO_SHEET                  	0x00040000L
#define OI_ANNO_STATE                  	0x00080000L
#define OI_ANNO_TRANS                  	0x00100000L
#define OI_ANNO_EVENT                  	0x00200000L
#define OI_ANNO_ACT_ACTION		0x00400000L
#define OI_ANNO_CF_ACTION		0x00800000L
/*
** IM Objects
*/
#define OI_ANNO_ERM			0x01000000L
#define OI_ANNO_ERD			0x02000000L
#define OI_ANNO_ENT			0x04000000L
#define OI_ANNO_REL			0x08000000L
#define OI_ANNO_CONN 			0x10000000L
#define OI_ANNO_ATTR			0x03000000L
/*
** TASK Objects
*/
#define OI_ANNO_TSK			0x00000003L
#define OI_ANNO_TSK_DIA			0x00000005L
#define OI_ANNO_TSK_EVENT		0x00000006L
#define OI_ANNO_TSK_MESS		0x00000007L
/*
** OO Objects
*/
#define OI_ANNO_OO_SUB			0x0000000aL
#define OI_ANNO_OO_CLASS		0x0000000bL
#define OI_ANNO_OO_EVTR			0x0000000cL
#define OI_ANNO_OO_OBJECT		0x0000000dL
#define OI_ANNO_OO_STD			0x0000000eL
/*
** General Objects
*/
#define OI_ANNO_PROJ                   	0x20000000L
#define OI_ANNO_DATA			0x40000000L
#define OI_ANNO_TYPE_TABLE             	0x50000000L

#define OI_ANNO_REF			struct oi_anno_ref
#define OI_ANNO_DESC			struct oi_anno_desc
#define OI_ANNO_COUNTER			struct oi_anno_counter

/*P*/
/*
**	ANNO_OBJ specific Structures
*/
#ifndef OI_HEADER	/* disabled by oi.h 	*/

OI_ANNO_COUNTER
    {
    INT			ref;
    INT			desc;
    };


OI_ANNO_REF
    {
    LONG		obj_type;
    PRD_OBJ_SPEC	name_1;
    PRD_OBJ_SPEC	name_2;
    PRD_OBJ_SPEC	name_3;
    LONG		no;
    LONG		anno_id;
    };

#ifndef RPC_XDR	/* don't generate conversion routine		*/

/*
 * Update xdr_oi_anno_desc() in oi_314xdr.c if structure changes !
 */
OI_ANNO_DESC
    {
    SHORT		attr_no;
    SHORT		line_no;
    SHORT		length;
    BYTE		*content;
    };


#ifndef RPC_SVC	/* should not seen by 'rpcgen'			*/
#ifndef RPC_CLNT
#ifndef RPC_HDR

typedef enum _OI_AA_AT_NOTNULL_TYPE
    {
    OI_AT_NONE,
    OI_AT_NULL,
    OI_AT_NOTNULL
    } OI_AA_AT_NOTNULL_TYPE;

typedef enum _OI_AA_CO_ONDELETE_TYPE
    {
    OI_CO_NONE,
    OI_CO_CASCADE
    } OI_AA_CO_ONDELETE_TYPE;

#endif
#endif
#endif

#endif /* RPC_XDR */

#endif		/* OI_HEADER	*/
